package com.daikin.wechat.api;

import com.daikin.wechat.config.ElasticsearchApi;
import org.apache.http.HttpHost;
import org.elasticsearch.client.RequestOptions;
import org.elasticsearch.client.RestClient;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.client.core.MainResponse;
import org.junit.jupiter.api.Test;

import java.io.IOException;

/**
 * test high level Java client
 *
 */
public class InfoApiTest {

    @Test
    public static void infoApiTest() {
        try (final RestHighLevelClient client = new RestHighLevelClient(
                RestClient.builder(
                        new HttpHost(ElasticsearchApi.HOST_NAME, ElasticsearchApi.PORT, ElasticsearchApi.SCHEME)
                )
        )) {
            final MainResponse response = client.info(RequestOptions.DEFAULT);

            System.out.println(response.getClusterName());
            System.out.println(response.getClusterUuid());
            System.out.println(response.getNodeName());
            System.out.println(response.getVersion());
            System.out.println(response.getTagline());
        } catch (final IOException e) {
            throw new RuntimeException(e);
        }
    }

    public static void main(String[] args) {
        infoApiTest();
        System.out.println("你好");
    }
}
