package com.daikin.wechat.service;

import com.haulmont.cuba.core.global.DataManager;
import com.haulmont.cuba.security.app.Authenticated;
import com.haulmont.cuba.security.app.Authentication;
import org.springframework.stereotype.Service;

import javax.inject.Inject;

@Service(CorpChatService.NAME)
public class CorpChatServiceBean implements CorpChatService {

    @Inject
    private DataManager dataManager;

    @Override
    public long loadChatSeqForCorp(String corp) {
        long seq = -1L;
        try {
            seq = dataManager.loadValue("select s.seq from wechat_CorpChatSeq s where " +
                    "s.corp = :corp", Long.class)
                    .parameter("corp", corp)
                    .one();
        }catch (IllegalStateException e){
            // 如果没有数据 one() 会抛出该异常
        }
        return seq;
    }
}