/*
 * work_wx
 * wuhen 2020/1/16.
 * Copyright (c) 2020  jianfengwuhen@126.com All Rights Reserved.
 */

package com.daikin.wechat.task;

import com.daikin.wechat.modle.ChatModel;
import com.daikin.wechat.modle.CorpModel;
import com.daikin.wechat.modle.KeywordConfigModel;
import com.daikin.wechat.tencent.Finance;
import com.daikin.wechat.util.BackUpUtil;
import com.google.gson.*;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.client.HttpClientErrorException;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class AuditBackUpUtil {

    private final static Logger logger = LoggerFactory.getLogger(AuditBackUpUtil.class);
    private static long sdk = 0;
    private static long timeout = 10 * 60 * 1000;

    private static void initSDK (String corpid, String secret) {
        if (sdk == 0) {
            sdk = Finance.NewSdk();
            Finance.Init(sdk,corpid,secret);
        }
    }


    /**
     * @todo
     * @param seq :
     * @param limit :
     * @returns boolean
     * @throws
     */
    public static boolean insertChat(String corpId, String priKey,long seq, long limit) {
        initSDK(corpId, priKey);
        int size = 0;
        long slice = Finance.NewSlice();
        long ret = Finance.GetChatData(sdk, seq, limit, "", "",timeout,slice);
        if (ret != 0) {
            logger.warn("获取存档消息 " + ret);
        } else {
            String content = Finance.GetContentFromSlice(slice);
            JsonArray jsonElements = JsonParser.parseString(content).getAsJsonObject().get("chatdata").getAsJsonArray();
            if (null != jsonElements && jsonElements.size() > 0) {

                size = jsonElements.size();

                //存到mq中


                //TODO 整体转移到消费者业务中处理  疑问: 媒体文件如何处理
                ChatModel chatModel = null;
                long newSlice = Finance.NewSlice();
                for (JsonElement jsonElement : jsonElements) {
                    try {
                        JsonObject jsonObject = jsonElement.getAsJsonObject();
                        long LocalSEQ = jsonObject.get("seq").getAsLong();
                        String key = BackUpUtil.decryptData(jsonObject.get("encrypt_random_key").getAsString());
                        int i = Finance.DecryptData(sdk, key, jsonObject.get("encrypt_chat_msg").getAsString(), newSlice);
                        if (i == 0) {
                            String msg = Finance.GetContentFromSlice(newSlice);
                            msg.replace("\"id\"", "table_id");
                            logger.debug(msg);
                            chatModel = new Gson().fromJson(msg,ChatModel.class);


                            //更新企业会话消息的seq

                            //存入es

                            //媒体文件存入阿里云

                            //整体信息存入阿里云 ??


                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
//                    list.add(chatModel);
                }
            }
        }
        Finance.FreeSlice(slice);
        return size == limit ? true:false;
    }


    /**
     * @todo
     * @param indexbuf :
     * @param sdkField :
     * @returns boolean
     * @throws
     */
    public static boolean getMediaData(String corpId, String secret, String indexbuf, String sdkField) {
        initSDK(corpId, secret);
        long slice = Finance.NewMediaData();
        long ret = Finance.GetMediaData(sdk, indexbuf, sdkField, "", "",timeout,slice);
        if (ret != 0) {
            logger.warn("获取媒体数据 " + ret);
        } else {
            logger.debug("upload media  "+sdkField);
            byte[] b = Finance.GetData(slice);
            boolean isFinish = Finance.IsMediaDataFinish(slice) > 0;
            String outIndex = Finance.GetOutIndexBuf(slice);
//            gridFSUploadStream.write(b);
            //todo 文件存到阿里云
            b = null;
            Finance.FreeMediaData(slice);
            if (isFinish) {
                logger.debug("upload media finish "+sdkField);
//                gridFSUploadStream.flush();
//                gridFSUploadStream.close();
            } else {
                getMediaData(corpId, secret,outIndex, sdkField);
            }
            return true;
        }
        return false;
    }





}
