/*
 * work_wx
 * wuhen 2020/1/16.
 * Copyright (c) 2020  jianfengwuhen@126.com All Rights Reserved.
 */

package com.daikin.wechat.task;

import com.daikin.wechat.service.CorpChatService;
import com.daikin.wechat.util.ConstantUtil;
import com.haulmont.addon.restapi.api.config.RestApiConfig;
import com.haulmont.cuba.core.global.DataManager;
import com.haulmont.cuba.core.sys.AppContext;
import com.haulmont.cuba.core.sys.SecurityContext;
import com.haulmont.cuba.security.app.TrustedClientService;
import com.haulmont.cuba.security.global.UserSession;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.inject.Inject;
import java.util.List;
import java.util.Map;

/**
 * 自动获取企业微信聊天记录
 */
@Component
@EnableScheduling
public class AutoBackUpAuditTask {
    private final static int LIMIT = 1000;
    private final static Logger logger = LoggerFactory.getLogger(AutoBackUpAuditTask.class);

    @Inject
    private CorpChatService corpChatService;
    @Inject
    private TrustedClientService trustedClientService;
    @Inject
    private RestApiConfig restApiConfig;

    /**
     * @todo 自动备份消息存档
     * @returns void
     * @throws
     */
    @Scheduled(fixedRate = 1000*60*1, initialDelay = 1000*10)
    public void backupWeChat() {

        Map<String,String> corps = ConstantUtil.CORP_PRI_KEY;
        UserSession anonymousSession = trustedClientService.getAnonymousSession(restApiConfig.getTrustedClientPassword(),
                restApiConfig.getSecurityScope());

        AppContext.setSecurityContext(new SecurityContext(anonymousSession));
        for (String corp : corps.keySet()) {

            //获取mysql中 该企业ID对应的seq
            long seq = 0;
            //todo

            seq = corpChatService.loadChatSeqForCorp(corp);

            logger.info("logback start backup seq start with:"+seq+",corp id:"+corp);

//            boolean repeat = AuditBackUpUtil.insertChat(corp
//                    , ConstantUtil.CORP_PUB_KEY.get(corp), seq,LIMIT);
//            if (repeat) {
//                backupWeChat();
//            }
        }

    }



    /**
     * @todo 自动备份媒体文件
     * @author wuhen
     * @returns void
     * @throws
     * @date 2020/1/27 13:14
     */
//    @Scheduled(fixedRate = 1000*60*6, initialDelay = 1000*20)
    public void backupWeChatData() {

        Map<String,String> corps = ConstantUtil.CORP_PUB_KEY;

        for (String corp : corps.keySet()) {

            //获取mysql中 该企业ID对应的seq
            long seq = 0;
            //todo
            logger.info("start backup seq start with:"+seq+",corp id:"+corp);

            //todo
//            MultiDataProcess.FileTypeProcess(chatServer,corpModel);

        }

    }


}
