/*
 * work_wx
 * wuhen 2020/1/16.
 * Copyright (c) 2020  jianfengwuhen@126.com All Rights Reserved.
 */

package com.daikin.wechat.token;

import com.daikin.wechat.modle.TokenModel;
import com.google.gson.Gson;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 获取通讯录
 */
public class ContactAccessToken {
    private final static Logger logger = LoggerFactory.getLogger(ContactAccessToken.class);
    public static final int CONTACT_TOKEN_TYPE = 1;

    public static final String BASE_ADDRESS = "https://qyapi.weixin.qq.com/cgi-bin/gettoken";

    public static String getContactAccessToken() {

        return requestContactToken("", "");
    }


    private static String requestContactToken(String corpId, String secret) {
        String url = BASE_ADDRESS + "?" + "corpid=" + corpId +"&" + "corpsecret=" + secret;

        try {
            Response response = new OkHttpClient().newCall(new Request.Builder().url(url).get().build()).execute();
            if (response.code() == 200) {
                TokenModel tokenModel = new Gson().fromJson(response.body().string(), TokenModel.class);
                if (tokenModel.getErrcode() == 0) {
                    logger.debug("requestContactToken:"+tokenModel.toString());
                    return tokenModel.getAccess_token();
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "";
    }




}
